(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-simple-print', ['exports', '@angular/core'], factory) :
    (global = global || self, factory(global['ngx-simple-print'] = {}, global.ng.core));
}(this, (function (exports, core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-simple-print.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxSimplePrintDirective = /** @class */ (function () {
        function NgxSimplePrintDirective() {
            this.sectionToPrintId = 'ngxSimplePrintSection';
        }
        /**
         * @return {?}
         */
        NgxSimplePrintDirective.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.printSection = document.getElementById(this.sectionToPrintId);
            if (!this.printSection) {
                this.addPrintableSection();
                this.addStyles();
            }
            window.onafterprint = (/**
             * @return {?}
             */
            function () {
                _this.printSection.innerHTML = '';
            });
        };
        /**
         * @return {?}
         */
        NgxSimplePrintDirective.prototype.onclickPrint = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var elemToPrint = document.getElementById(this.printContentId);
            if (elemToPrint) {
                this.printSection.innerHTML = '';
                this.printElement(elemToPrint);
            }
        };
        /**
         * @param {?} elem
         * @return {?}
         */
        NgxSimplePrintDirective.prototype.printElement = /**
         * @param {?} elem
         * @return {?}
         */
        function (elem) {
            /** @type {?} */
            var domClone = elem.cloneNode(true);
            this.printSection.appendChild(domClone);
            window.print();
        };
        /**
         * @return {?}
         */
        NgxSimplePrintDirective.prototype.addPrintableSection = /**
         * @return {?}
         */
        function () {
            this.printSection = document.createElement('div');
            this.printSection.id = this.sectionToPrintId;
            document.body.appendChild(this.printSection);
        };
        /**
         * @return {?}
         */
        NgxSimplePrintDirective.prototype.addStyles = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var style = document.createElement('style');
            style.type = 'text/css';
            style.appendChild(document.createTextNode("\n        @media screen {\n            #ngxSimplePrintSection {\n                display: none;\n            }\n        }\n        @media print {\n            body * {\n                visibility:hidden;\n            }\n            #ngxSimplePrintSection, #ngxSimplePrintSection * {\n                visibility:visible;\n            }\n            #ngxSimplePrintSection {\n                position:absolute;\n                left:0;\n                top:0;\n            }\n        }\n      "));
            document.body.appendChild(style);
        };
        NgxSimplePrintDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[roNgxSimplePrint]'
                    },] }
        ];
        /** @nocollapse */
        NgxSimplePrintDirective.ctorParameters = function () { return []; };
        NgxSimplePrintDirective.propDecorators = {
            printContentId: [{ type: core.Input }],
            onclickPrint: [{ type: core.HostListener, args: ['click',] }]
        };
        return NgxSimplePrintDirective;
    }());
    if (false) {
        /** @type {?} */
        NgxSimplePrintDirective.prototype.printSection;
        /** @type {?} */
        NgxSimplePrintDirective.prototype.sectionToPrintId;
        /** @type {?} */
        NgxSimplePrintDirective.prototype.printContentId;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/ngx-simple-print.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxSimplePrintModule = /** @class */ (function () {
        function NgxSimplePrintModule() {
        }
        NgxSimplePrintModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [NgxSimplePrintDirective],
                        imports: [],
                        exports: [NgxSimplePrintDirective]
                    },] }
        ];
        return NgxSimplePrintModule;
    }());

    exports.NgxSimplePrintModule = NgxSimplePrintModule;
    exports.ɵa = NgxSimplePrintDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-simple-print.umd.js.map
