import { Directive, Input, HostListener, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-simple-print.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxSimplePrintDirective {
    constructor() {
        this.sectionToPrintId = 'ngxSimplePrintSection';
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.printSection = document.getElementById(this.sectionToPrintId);
        if (!this.printSection) {
            this.addPrintableSection();
            this.addStyles();
        }
        window.onafterprint = (/**
         * @return {?}
         */
        () => {
            this.printSection.innerHTML = '';
        });
    }
    /**
     * @return {?}
     */
    onclickPrint() {
        /** @type {?} */
        const elemToPrint = document.getElementById(this.printContentId);
        if (elemToPrint) {
            this.printSection.innerHTML = '';
            this.printElement(elemToPrint);
        }
    }
    /**
     * @param {?} elem
     * @return {?}
     */
    printElement(elem) {
        /** @type {?} */
        const domClone = elem.cloneNode(true);
        this.printSection.appendChild(domClone);
        window.print();
    }
    /**
     * @return {?}
     */
    addPrintableSection() {
        this.printSection = document.createElement('div');
        this.printSection.id = this.sectionToPrintId;
        document.body.appendChild(this.printSection);
    }
    /**
     * @return {?}
     */
    addStyles() {
        /** @type {?} */
        const style = document.createElement('style');
        style.type = 'text/css';
        style.appendChild(document.createTextNode(`
        @media screen {
            #ngxSimplePrintSection {
                display: none;
            }
        }
        @media print {
            body * {
                visibility:hidden;
            }
            #ngxSimplePrintSection, #ngxSimplePrintSection * {
                visibility:visible;
            }
            #ngxSimplePrintSection {
                position:absolute;
                left:0;
                top:0;
            }
        }
      `));
        document.body.appendChild(style);
    }
}
NgxSimplePrintDirective.decorators = [
    { type: Directive, args: [{
                selector: '[roNgxSimplePrint]'
            },] }
];
/** @nocollapse */
NgxSimplePrintDirective.ctorParameters = () => [];
NgxSimplePrintDirective.propDecorators = {
    printContentId: [{ type: Input }],
    onclickPrint: [{ type: HostListener, args: ['click',] }]
};
if (false) {
    /** @type {?} */
    NgxSimplePrintDirective.prototype.printSection;
    /** @type {?} */
    NgxSimplePrintDirective.prototype.sectionToPrintId;
    /** @type {?} */
    NgxSimplePrintDirective.prototype.printContentId;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-simple-print.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxSimplePrintModule {
}
NgxSimplePrintModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxSimplePrintDirective],
                imports: [],
                exports: [NgxSimplePrintDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-simple-print.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxSimplePrintModule, NgxSimplePrintDirective as ɵa };
//# sourceMappingURL=ngx-simple-print.js.map
