import { Directive, Input, HostListener, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-simple-print.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxSimplePrintDirective = /** @class */ (function () {
    function NgxSimplePrintDirective() {
        this.sectionToPrintId = 'ngxSimplePrintSection';
    }
    /**
     * @return {?}
     */
    NgxSimplePrintDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.printSection = document.getElementById(this.sectionToPrintId);
        if (!this.printSection) {
            this.addPrintableSection();
            this.addStyles();
        }
        window.onafterprint = (/**
         * @return {?}
         */
        function () {
            _this.printSection.innerHTML = '';
        });
    };
    /**
     * @return {?}
     */
    NgxSimplePrintDirective.prototype.onclickPrint = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var elemToPrint = document.getElementById(this.printContentId);
        if (elemToPrint) {
            this.printSection.innerHTML = '';
            this.printElement(elemToPrint);
        }
    };
    /**
     * @param {?} elem
     * @return {?}
     */
    NgxSimplePrintDirective.prototype.printElement = /**
     * @param {?} elem
     * @return {?}
     */
    function (elem) {
        /** @type {?} */
        var domClone = elem.cloneNode(true);
        this.printSection.appendChild(domClone);
        window.print();
    };
    /**
     * @return {?}
     */
    NgxSimplePrintDirective.prototype.addPrintableSection = /**
     * @return {?}
     */
    function () {
        this.printSection = document.createElement('div');
        this.printSection.id = this.sectionToPrintId;
        document.body.appendChild(this.printSection);
    };
    /**
     * @return {?}
     */
    NgxSimplePrintDirective.prototype.addStyles = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var style = document.createElement('style');
        style.type = 'text/css';
        style.appendChild(document.createTextNode("\n        @media screen {\n            #ngxSimplePrintSection {\n                display: none;\n            }\n        }\n        @media print {\n            body * {\n                visibility:hidden;\n            }\n            #ngxSimplePrintSection, #ngxSimplePrintSection * {\n                visibility:visible;\n            }\n            #ngxSimplePrintSection {\n                position:absolute;\n                left:0;\n                top:0;\n            }\n        }\n      "));
        document.body.appendChild(style);
    };
    NgxSimplePrintDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[roNgxSimplePrint]'
                },] }
    ];
    /** @nocollapse */
    NgxSimplePrintDirective.ctorParameters = function () { return []; };
    NgxSimplePrintDirective.propDecorators = {
        printContentId: [{ type: Input }],
        onclickPrint: [{ type: HostListener, args: ['click',] }]
    };
    return NgxSimplePrintDirective;
}());
if (false) {
    /** @type {?} */
    NgxSimplePrintDirective.prototype.printSection;
    /** @type {?} */
    NgxSimplePrintDirective.prototype.sectionToPrintId;
    /** @type {?} */
    NgxSimplePrintDirective.prototype.printContentId;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-simple-print.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxSimplePrintModule = /** @class */ (function () {
    function NgxSimplePrintModule() {
    }
    NgxSimplePrintModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxSimplePrintDirective],
                    imports: [],
                    exports: [NgxSimplePrintDirective]
                },] }
    ];
    return NgxSimplePrintModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-simple-print.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxSimplePrintModule, NgxSimplePrintDirective as ɵa };
//# sourceMappingURL=ngx-simple-print.js.map
